/*******************************************************************************
 * This file is part of OpenNMS(R).
 *
 * Copyright (C) 2006-2013 The OpenNMS Group, Inc.
 * OpenNMS(R) is Copyright (C) 1999-2013 The OpenNMS Group, Inc.
 *
 * OpenNMS(R) is a registered trademark of The OpenNMS Group, Inc.
 *
 * OpenNMS(R) is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * OpenNMS(R) is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenNMS(R).  If not, see:
 *      http://www.gnu.org/licenses/
 *
 * For more information contact:
 *     OpenNMS(R) Licensing <license@opennms.org>
 *     http://www.opennms.org/
 *     http://www.opennms.com/
 *******************************************************************************/
package org.opennms.netmgt.vmmgr;

/**
 * The Class ControllerUtils.
 * 
 * @author Alejandro Galue <agalue@opennms.org>
 */
public class ControllerUtils {

    /** The controller. */
    private static Controller controller;

    /**
     * Gets the controller.
     *
     * @return the controller
     */
    public static Controller getController() {
        if (controller == null) {
            controller = new Controller();
            controller.setInvokeUrl("http://127.0.0.1:8181/invoke?objectname=OpenNMS:Name=Manager");
            controller.setAuthenticator(controller.createAuthenticatorUsingConfigCredentials());
        }
        return controller;
    }

}
